/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-09-10 21:29
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll MAXN = 2e5 + 5;
const ll INF = 1LL << 60;

ll N, K, start, target;

void solve(){
    // Code goes here ...
    cin >> N >> K >> start >> target;

    vector<ll> xs(N), ys(N);
    R(i, N) cin >> xs[i] >> ys[i];

    start--, target--;
    ll a = INF, b = INF;
    R(i, K) ckmin(a, abs(xs[start] - xs[i]) + abs(ys[start] - ys[i]));
    R(i, K) ckmin(b, abs(xs[target] - xs[i]) + abs(ys[target] - ys[i]));

    cout << min(a + b, abs(xs[start] - xs[target]) + abs(ys[start] - ys[target])) << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    cin >> T;
    while(T--)
        solve();

    /* string rest; */
    /* while(cin.peek() != char_traits<char>::eof()){ */
    /*     solve(); */
    /*     getline(cin, rest); */
    /* } */

    return 0;
}
        
